package com.zykj.temperaturedemo;

import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {
    private TextView tv_info;
    private TempDataReceiveTTL tempDataReceiveTTL;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        tv_info = findViewById(R.id.tv_info);

        tempDataReceiveTTL = new TempDataReceiveTTL();
        if(tempDataReceiveTTL.open()){
            Toast.makeText(this,"测温模块连接成功",Toast.LENGTH_SHORT).show();

            temperatureThread = new AutoGetTemperatureThread();
            temperatureThread.start();

        } else {
            Toast.makeText(this,"测温模块连接失败",Toast.LENGTH_SHORT).show();
        }
    }

    private AutoGetTemperatureThread temperatureThread;
    private class AutoGetTemperatureThread extends Thread {
        private boolean isRun = true;

        public void stopWork() {
            isRun = false;
            interrupt();;
        }

        @Override
        public void run() {
            byte[] data = new byte[10];
            while(isRun) {
                float temp = tempDataReceiveTTL.getBodyTempData(data);

                if(mHandler!=null) {
                    mHandler.obtainMessage(2,String.format("%.2f",temp)).sendToTarget();
                }

                try {
                    Thread.sleep(200);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private Handler mHandler = new Handler() {
        public void handleMessage(Message msg) {
            switch(msg.what){
                case 2:
                    tv_info.setText((String)msg.obj);
                    break;
            }
        };
    };

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if(temperatureThread!=null) {
            temperatureThread.stopWork();
            temperatureThread = null;
        }

        if(tempDataReceiveTTL!=null) {
            tempDataReceiveTTL.destroy();
            tempDataReceiveTTL = null;
        }
        if(mHandler!=null) {
            mHandler.removeCallbacksAndMessages(null);
            mHandler =null;
        }
    }
}
