package com.zykj.temperaturedemo;


import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import android_serialport_api.SerialPort;

public class TTLReceiveBase implements TTLInterface {
    protected SerialPort mSerialPort;
    protected InputStream input;
    protected OutputStream output;
    protected String sPort = "";
    protected int iBaudRate = 115200;

    protected boolean isOpened = false;

    @Override
    public void setBaudRateAndPort(String port, int baudRate) {
        sPort = port;
        iBaudRate = baudRate;
    }

    /**
     * 打开串口
     * */
    public boolean openSerialPort(){
        close();
        try {
            mSerialPort = new SerialPort(new File(sPort), iBaudRate, 0);
            input = mSerialPort.getInputStream();
            output = mSerialPort.getOutputStream();
            isOpened = true;
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            close();
        }
        return false;
    }

    /**
     * 关闭串口
     * */
    protected void close() {
        if(input!=null) {
            try {
                input.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            input = null;
        }
        if(output!=null) {
            try {
                output.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            output = null;
        }
        if (mSerialPort != null) {
            mSerialPort.close();
            mSerialPort = null;
        }
        isOpened = false;
    }

    /**
     * 跳过缓存数据
     * */
    protected void skipCacheData() {
        try {
            int availavleLeng = 0;
            while((availavleLeng = input.available())>0) {
                availavleLeng = input.read(new byte[availavleLeng]);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
